// Fill out your copyright notice in the Description page of Project Settings.


#include "RenderTextureCollect.h"
#include "Engine\TextureRenderTarget2D.h"
#include "RenderCommandFence.h"
#include "RHICommandList.h"
#include "FrameGrabber.h"
#include "Editor.h"
#include "IAssetViewport.h"
#include "Slate\SceneViewport.h"
#include "FLiveFrameGrabber.h"
#include "LevelEditor.h"
#include "Modules\ModuleManager.h"
#include "IAssetViewport.h"
#include "VirtualCameraTool.h"
#include "Async/Async.h"


RenderTextureCollect::RenderTextureCollect()
{

}

RenderTextureCollect::~RenderTextureCollect()
{
}

bool RenderTextureCollect::StartCollect(FRenderTarget* Obj)
{
	RenderTarget = Obj;
	StopGrabber = false;

	FLevelEditorModule* LevelEditor = FModuleManager::GetModulePtr<FLevelEditorModule>("LevelEditor");
	auto ViewPort = LevelEditor->GetFirstActiveViewport()->GetSharedActiveViewport();
	FIntPoint FrameGrabberSize(ViewPort->GetSizeXY().X, ViewPort->GetSizeXY().Y);

	LiveFrameGrabber = MakeShared<FLiveFrameGrabber>(RenderTarget, FrameGrabberSize);
	if (LiveFrameGrabber.IsValid())
	{
		LiveFrameGrabber->StartCapturingFrames();
	}
	//FrameGrabber = MakeShared<FFrameGrabber>(ViewPort.ToSharedRef(), FrameGrabberSize);
	//if (FrameGrabber.IsValid())
	//{
	//	FrameGrabber->StartCapturingFrames();
	//	
	//}


	return true;
}

void RenderTextureCollect::StopCollect()
{
	StopGrabber = true;
	//if (FrameGrabber.IsValid())
	//{
	//	FrameGrabber->StopCapturingFrames();
	//}
	if (LiveFrameGrabber.IsValid())
	{
		LiveFrameGrabber->StopCapturingFrames();
	}
}

void RenderTextureCollect::StartSend()
{
	bEnableSend = true;
}

void RenderTextureCollect::StopSend()
{
	bEnableSend = false;
}

void RenderTextureCollect::Update(float dt)
{

	/*if (RenderTarget && !LastExecing)
	{
		LastFrame.Width = RenderTarget->GetSizeXY().X;
		LastFrame.Height = RenderTarget->GetSizeXY().Y;
		ReadPixels(LastFrame.Colors, LastFrame.Width, LastFrame.Height);
		LastExecing = true;
		Fence.BeginFence(false);
	}
	else if (LastExecing)
	{
		if (Fence.IsFenceComplete() && LastFrame.Colors.Num() > 0)
		{
			if (SurfDatas.Num() >= 2)
			{
				SurfDatas.RemoveAt(0);
			}
			SurfDatas.Add(LastFrame);
			LastExecing = false;
		}
	}*/
	if (StopGrabber)
	{
		return;
	}
	if (LiveFrameGrabber.IsValid())
	{
		if (LiveFrameGrabber)
		{
			LiveFrameGrabber->CaptureThisFrame(FFramePayloadPtr());

			TArray<FCapturedFrameData> Frames = LiveFrameGrabber->GetCapturedFrames();

			if (Frames.Num() && bEnableSend)
			{
				FCapturedFrameData& LastFrame = Frames.Last();
				FIntPoint Size = LastFrame.BufferSize;
				VirtualCameraTool::Get()->SendTextureColor(Size.X, Size.Y, LastFrame.ColorBuffer, 80);

			}
		}
	}
	//if (FrameGrabber.IsValid())
	//{
	//	if (FrameGrabber)
	//	{
	//		FrameGrabber->CaptureThisFrame(FFramePayloadPtr());

	//		TArray<FCapturedFrameData> Frames = FrameGrabber->GetCapturedFrames();

	//		if (Frames.Num() && bEnableSend)
	//		{
	//			FCapturedFrameData& LastFrame = Frames.Last();
	//			FIntPoint Size = LastFrame.BufferSize;
	//			//TArray<FColor> ColorData = MoveTemp(LastFrame.ColorBuffer);
	//			VirtualCameraTool::Get()->SendTextureColor(Size.X, Size.Y, LastFrame.ColorBuffer, 80);
	//			
	//		}
	//	}
	//}
	//if (ClientRole.IsValid() && ClientRole->IsConnected())
	//{
	//	TSharedPtr<FRemoteSessionImageChannel> Channel = ClientRole->GetChannel<FRemoteSessionImageChannel>();
	//	Channel->Tick(dt);
	//}
}

void RenderTextureCollect::ReadPixels(TArray<FColor>& OutImageData, int width, int height)
{

	//auto InRect = FIntRect(0, 0, width, height);
	//FReadSurfaceDataFlags InFlags = FReadSurfaceDataFlags(RCM_UNorm, CubeFace_MAX);
	//// Read the render target surface data back.	
	//struct FReadSurfaceContext
	//{
	//	FRenderTarget* SrcRenderTarget;
	//	TArray<FColor>* OutData;
	//	FIntRect Rect;
	//	FReadSurfaceDataFlags Flags;
	//};

	//OutImageData.Reset();
	//FReadSurfaceContext Context =
	//{
	//	RenderTarget,
	//	&OutImageData,
	//	InRect,
	//	InFlags
	//};

	//ENQUEUE_RENDER_COMMAND(ReadSurfaceCommand)(
	//	[=](FRHICommandListImmediate& RHICmdList)
	//{
	//	RHICmdList.ReadSurfaceData(
	//		Context.SrcRenderTarget->GetRenderTargetTexture(),
	//		Context.Rect,
	//		*Context.OutData,
	//		Context.Flags
	//	);
	//	
	//});
}
