// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "HAL/Runnable.h"
#include "HAL/RunnableThread.h"
/**
 * 
 */


class FLiveFrameGrabber;
class FFrameGrabber;
class UTextureRenderTarget2D;
class FRemoteSessionFrameBufferImageProvider;
class RenderTextureCollect
{
public:
	RenderTextureCollect();
	~RenderTextureCollect();

	bool StartCollect(FRenderTarget* Obj);
	void StopCollect();

	void StartSend();
	void StopSend();

	void Update(float dt);
protected:

	void ReadPixels(TArray<FColor>& SurfData, int width, int height);
private:

	bool StopGrabber;
	bool bEnableSend;

	FRenderTarget* RenderTarget;

	TSharedPtr<class FFrameGrabber> FrameGrabber;
	TSharedPtr<FLiveFrameGrabber> LiveFrameGrabber;
};
